#ifdef solaris
/****************************************************************
*
* SUN_dc_xtrl.c
*
* Hack to control DC in an HP DDS drive from a SUN
*
* Use: SUN_dc_xtrl device-file-name  1   Turns DC on
*      SUN_dc_xtrl device-file-name  0   Turns DC off
*
* Note: Switch 2 on the underside of the drive must be ON
*       in order for this utility to work.
*
******************************************************************
* Kevin Jones.                       | Hewlett Packard Ltd,
*                                    | Computer Peripherals Bristol,
* kev%hpcpbla@hplb.hpl.hp.com        | Filton Road,
*                                    | Stoke Gifford,
*                                    | Bristol.   BS12 6QZ.
*                                    | ENGLAND.
******************************************************************
*
* This code is not official HP code.
* It is provided for informational purposes only.
* It is supplied without warranty of any kind.
*
****************************************************************/

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/ioctl.h>

#include <sys/scsi/generic/mode.h>
#include <sys/scsi/generic/commands.h>
#include <sys/scsi/impl/types.h>
#include <sys/scsi/impl/uscsi.h>

int fd;
unsigned char msel_data[] = { 0,0,0x10,0,0xf,0xe,0x40,0x80,0,0,0,0x20,0,0,0,0,0,0,0,0 };

main (argc, argv)
int  argc;
char *argv[];

{ struct uscsi_cmd  scsi_cmd, *cmd = &scsi_cmd;
  char cmd_cdb[6];

  if (argc != 3) {
     printf ("Usage: SUN_dc_xtrl device-file-name [01]\n");
     exit (8);
  }

  if ((fd = open(argv[1], O_RDWR | O_NONBLOCK)) < 0)
   { if ((fd = open(argv[1], O_RDWR | O_NONBLOCK)) < 0)
      { printf ("Failed to open device %s\n", argv[1]);
        exit (1);
      }
   }

  if (*(argv[2]) == '1')
     msel_data[6] = 0xC0;

  cmd->uscsi_cdblen    = 0x06;
  cmd->uscsi_timeout   = 5000;
  cmd->uscsi_flags     = USCSI_WRITE;
  cmd->uscsi_bufaddr   = msel_data;
  cmd->uscsi_buflen    = sizeof (msel_data);
  cmd->uscsi_cdb     = cmd_cdb;
  cmd->uscsi_cdb[0]  = 0x15;
  cmd->uscsi_cdb[1]  = 0x10;
  cmd->uscsi_cdb[2]  = 0x0;
  cmd->uscsi_cdb[3]  = 0x0;
  cmd->uscsi_cdb[4]  = 0x14;
  cmd->uscsi_cdb[5]  = 0x0;

  if (ioctl (fd, USCSICMD ,cmd) < 0)
   { printf ("Mode Select command failed :-(\n");
     exit (1);
   }

  exit (0);
}
#endif /* solaris */
#ifdef linux
int main()
{
    return (0);
}
#endif /* linux */

