"
" NOTE: Start with gvim -U i-path.vim
"
" Save options
:let s:cpo_save = &cpo
:set cpo&vim
"
" Define a function to put in the #include stuff
"
:function! Include()
:    " Get the current line
:    let l:line = getline(".")
:
:    let l:dir_list = split(&path, ",")
:    " Loop through the local directories looking for the file
:    for l:cur_dir in l:dir_list
:       if (filereadable(l:cur_dir."/".l:line)) 
:
:	    " System directory?
:           if (match(l:cur_dir, "/usr/include") == 0)
:            
:	        " Put the #include in the right place
:               let l:line = "#include <".l:line.">"
:           else
:	        " Put the #include in the right place
:               let l:line = "#include \"".l:line."\""
:           endif
:
:           call setline(".", l:line)
:           return
:       endif
:    endfor
:
:    "At this point we did not find anything
:    "We could put in a default
:endfunction

" Now generate a way of calling the function
:map <F11> :call Include()<CR>

" Restore the previous value of 'cpoptions'.
:let &cpo = s:cpo_save
:unlet s:cpo_save
:source ~/.gvimrc
