use strict;
use warnings;
use constant FUDGE => 2;

sub make_tab(@) 
{
    my @lines = @_;	# The lines to split up
    my @data;		# The split apart lines
    my @size;		# Sizes of the columns

    foreach my $line (@lines) {
	# Split the line into words
	my @words = split /\s+/, $line;

	push(@data, [@words]);
	for (my $i = 0; $i <= $#words; ++$i) {
	    if (defined($size[$i])) {
		if (length($words[$i]) <= ($size[$i]- FUDGE)) {
		    next;
		}
	    }
 	
	    $size[$i] = length($words[$i]) + FUDGE;
	}
    }
    my @result;	# resulting line
    foreach my $cur_line (@data) {
	my $new_line = ""; # Line we are building up

	for (my $i = 0; $i <= $#$cur_line; ++$i) {
	    my $width = $size[$i]; # Size of this col
	    my $word = $cur_line->[$i];
 	    while (length($word) < $width) {
		$word .= ".";
	    }
	    $new_line .= $word;
	}
	push (@result, $new_line);
    }
    return (@result);
}
1;
